#ifndef _MENU_8D2E57C4_DDDD_479E_884E_7C44929FE595_
#define _MENU_8D2E57C4_DDDD_479E_884E_7C44929FE595_

#include <sal.h>


// Replace color in DIB palette
#include <windows.h>
#ifdef _ATL_MIN_CRT
RGBQUAD __clrtbl[256*sizeof(RGBQUAD)]; // make it a global var if you have more than 4k of stack (needs __chkstk()) and not using crt
#endif
inline BOOL ReplaceDIBColor(__inout HBITMAP* pDIB, __in COLORREF oldColor, __in COLORREF newColor)
{
	if (pDIB==NULL) return FALSE;
	if (oldColor==newColor) return TRUE;//nothing to do
	BOOL bRet=FALSE;

	//get color information
	DIBSECTION ds;
	if (!::GetObject(*pDIB, sizeof(DIBSECTION), &ds)) return FALSE;
	UINT nColors = ds.dsBmih.biClrUsed ? ds.dsBmih.biClrUsed : 1<<ds.dsBmih.biBitCount;//bpp to UINT
	if (ds.dsBmih.biBitCount>8 || nColors>256) return FALSE;//8bpp is max

	HDC hDC=::CreateCompatibleDC(NULL);
	if (!hDC) return FALSE;
	HBITMAP hbmpOld=(HBITMAP)::SelectObject(hDC, *pDIB);
	if (hbmpOld!=NULL)
	{	//replace color table entries
#ifndef _ATL_MIN_CRT
		RGBQUAD __clrtbl[256*sizeof(RGBQUAD)]; // make it a global var if you have more than 4k of stack (needs __chkstk()) and not using crt 
#endif
		if (::GetDIBColorTable(hDC, 0, nColors, __clrtbl))
		{
			UINT i;
			for (i=0; i<nColors; i++)
			{
				if (oldColor==RGB(__clrtbl[i].rgbRed, __clrtbl[i].rgbGreen, __clrtbl[i].rgbBlue))
				{
					__clrtbl[i].rgbRed=GetRValue(newColor);
					__clrtbl[i].rgbGreen=GetGValue(newColor);
					__clrtbl[i].rgbBlue=GetBValue(newColor);
					bRet=TRUE;
				}
			}
			if (bRet)//set new table
				if (!::SetDIBColorTable(hDC, 0, nColors, __clrtbl)) bRet=FALSE;
		}
	*pDIB=(HBITMAP)::SelectObject(hDC, hbmpOld);
	}
	::DeleteDC(hDC);
return bRet;
}

#endif//_MENU_8D2E57C4_DDDD_479E_884E_7C44929FE595_
